# Container image
image: node:slim

# Stages
stages:
  - setup
  - build
  - test
  - release

# Setup jobs
install-dependencies:
  image: andreysenov/node-gyp
  stage: setup
  script:
    - npm ci
  cache:
    paths:
      - node_modules/
  artifacts:
    paths:
      - node_modules/

# Test jobs
unit-tests:
  stage: test
  script:
    - npm run test

sonarqube-check:
  stage: test
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  variables:
    SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar" # Defines the location of the analysis task cache
    GIT_DEPTH: "0" # Tells git to fetch all the branches of the project, required by the analysis task
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - sonar-scanner
  allow_failure: true

# Build jobs
build:
  stage: build
  script:
    - npm run build

# Release new version
create-release:
  image: node:lts-alpine3.14
  stage: release
  before_script:
    - apk --no-cache add git
    - npm i @semantic-release/changelog @semantic-release/git @semantic-release/gitlab
    - npx husky install
    - npx husky add .husky/commit-msg 'npx --no-install commitlint --edit $1'
  script: npx semantic-release
  only:
    refs:
      - main
